import { toRefs as w, defineAsyncComponent as e, computed as s, ref as o, onMounted as tt, watch as G, shallowReactive as et, createElementBlock as ot, createBlock as m, openBlock as c, normalizeStyle as it, createElementVNode as at, createTextVNode as nt, createCommentVNode as M, toDisplayString as rt, resolveDynamicComponent as lt, mergeProps as ut, toHandlers as st, createSlots as ct, renderList as gt, withCtx as pt, renderSlot as mt, normalizeProps as dt, guardReactiveProps as Vt } from "vue";
import $ from "./BaseIcon-DTJIrD3k.js";
const Ut = { style: { width: "36px" } }, St = {
  __name: "vue-data-ui",
  props: {
    component: { type: String },
    dataset: { type: [Object, Array, Number, String] },
    config: { type: Object }
  },
  emits: [
    "selectLegend",
    "selectDatapoint",
    "toggleOpenState",
    "saveAnnotations",
    "selectRoot",
    "selectBranch",
    "selectNut",
    "change",
    "selectPlot",
    "selectSide",
    "rate",
    "postImage",
    "hoverIndex",
    "selectX",
    "toggleLock",
    "toggleTooltip",
    "start",
    "play",
    "pause",
    "reset",
    "restart",
    "lap",
    "toggleAnnotator"
  ],
  setup(W, { expose: X, emit: Q }) {
    const n = W, { component: ft, dataset: j, config: z } = w(n), g = {
      VueUi3dBar: e(() => import("./vue-ui-3d-bar-DbhESYsC.js")),
      VueUiAgePyramid: e(() => import("./vue-ui-age-pyramid-CxW84Zy4.js")),
      VueUiAnnotator: e(() => import("./vue-ui-annotator-DuS_kY-C.js")),
      VueUiCandlestick: e(() => import("./vue-ui-candlestick-C76ZVkkY.js")),
      VueUiChestnut: e(() => import("./vue-ui-chestnut-CB4BA3mx.js")),
      VueUiDashboard: e(() => import("./vue-ui-dashboard-BIQYUy0X.js")),
      VueUiDigits: e(() => import("./vue-ui-digits-B9zkzbxp.js")),
      VueUiDonut: e(() => import("./vue-ui-donut-CTTVwsjp.js")),
      VueUiDonutEvolution: e(() => import("./vue-ui-donut-evolution-QrqawlMF.js")),
      VueUiGalaxy: e(() => import("./vue-ui-galaxy-DKsUFAVZ.js")),
      VueUiGauge: e(() => import("./vue-ui-gauge-CVS_Ragk.js")),
      VueUiHeatmap: e(() => import("./vue-ui-heatmap-BGioOZJj.js")),
      VueUiKpi: e(() => import("./vue-ui-kpi-BK1Vq6tA.js")),
      VueUiMiniLoader: e(() => import("./vue-ui-mini-loader-lAOgjMme.js")),
      VueUiMolecule: e(() => import("./vue-ui-molecule-DEKmU-Mx.js")),
      VueUiMoodRadar: e(() => import("./vue-ui-mood-radar-6XZfljIe.js")),
      VueUiNestedDonuts: e(() => import("./vue-ui-nested-donuts-Cl8xdJU6.js")),
      VueUiOnion: e(() => import("./vue-ui-onion-CPlqANiN.js")),
      VueUiQuadrant: e(() => import("./vue-ui-quadrant-C_BIZcc8.js")),
      VueUiRadar: e(() => import("./vue-ui-radar-Ddu3Dzxx.js")),
      VueUiRating: e(() => import("./vue-ui-rating-C7MH_wxf.js")),
      VueUiRelationCircle: e(() => import("./vue-ui-relation-circle-B_xPyr_-.js")),
      VueUiRings: e(() => import("./vue-ui-rings-pjfgnXyP.js")),
      VueUiScatter: e(() => import("./vue-ui-scatter-x6zrT3IA.js")),
      VueUiScreenshot: e(() => import("./vue-ui-screenshot-DeKe5Csw.js")),
      VueUiSkeleton: e(() => import("./vue-ui-skeleton-BC7kQhlE.js")),
      VueUiSmiley: e(() => import("./vue-ui-smiley-5evB5mWX.js")),
      VueUiSparkbar: e(() => import("./vue-ui-sparkbar-DkAi7xTy.js")),
      VueUiSparkgauge: e(() => import("./vue-ui-sparkgauge-BPhv4OLb.js")),
      VueUiSparkHistogram: e(() => import("./vue-ui-sparkhistogram-CvhqCMzj.js")),
      VueUiSparkline: e(() => import("./vue-ui-sparkline-TSwCmhPw.js")),
      VueUiSparkStackbar: e(() => import("./vue-ui-sparkstackbar-BoS2_lla.js")),
      VueUiTable: e(() => import("./vue-ui-table-Cdn-p4Sv.js")),
      VueUiTableSparkline: e(() => import("./vue-ui-table-sparkline-B6WbUZ-8.js")),
      VueUiThermometer: e(() => import("./vue-ui-thermometer-CYPaaRUL.js")),
      VueUiTiremarks: e(() => import("./vue-ui-tiremarks-LeiTjrNE.js")),
      VueUiTreemap: e(() => import("./vue-ui-treemap-D1qUMxJQ.js")),
      VueUiVerticalBar: e(() => import("./vue-ui-vertical-bar-BjqeLwN6.js")),
      VueUiWaffle: e(() => import("./vue-ui-waffle-DphHhyQF.js")),
      VueUiWheel: e(() => import("./vue-ui-wheel-BloNNVqT.js")),
      VueUiXy: e(() => import("./vue-ui-xy-Zy60Z2c1.js")),
      VueUiTableHeatmap: e(() => import("./vue-ui-table-heatmap-DUoSqJAq.js")),
      VueUiAccordion: e(() => import("./vue-ui-accordion-CE2Pnpz3.js")),
      VueUiQuickChart: e(() => import("./vue-ui-quick-chart-BZ5n0UQy.js")),
      VueUiCursor: e(() => import("./vue-ui-cursor-CNrbLYcU.js")),
      VueUiSparkTrend: e(() => import("./vue-ui-spark-trend-BgZ0JbXH.js")),
      VueUiStripPlot: e(() => import("./vue-ui-strip-plot-Cbd43lkd.js")),
      VueUiDumbbell: e(() => import("./vue-ui-dumbbell-DbJC4PQf.js")),
      VueUiWordCloud: e(() => import("./vue-ui-word-cloud-wxMpsmI9.js")),
      VueUiXyCanvas: e(() => import("./vue-ui-xy-canvas-zINzDQlN.js")),
      VueUiFlow: e(() => import("./vue-ui-flow-oXRtEqoD.js")),
      VueUiParallelCoordinatePlot: e(() => import("./vue-ui-parallel-coordinate-plot-95RlJka2.js")),
      VueUiTimer: e(() => import("./vue-ui-timer-DVDPJaIq.js")),
      VueUiCarouselTable: e(() => import("./vue-ui-carousel-table-DPlos7Us.js")),
      VueUiGizmo: e(() => import("./vue-ui-gizmo-D4BHhwJ8.js")),
      VueUiStackbar: e(() => import("./vue-ui-stackbar-BEN8-V44.js")),
      VueUiBullet: e(() => import("./vue-ui-bullet-CvB9cU_g.js")),
      VueUiFunnel: e(() => import("./vue-ui-funnel-wG5mmmoA.js")),
      VueUiHistoryPlot: e(() => import("./vue-ui-history-plot-B18G7ARJ.js")),
      VueUiCirclePack: e(() => import("./vue-ui-circle-pack-DslAztEw.js"))
    }, K = {
      VueUi3dBar: ["config", "dataset"],
      VueUiAgePyramid: ["config", "dataset"],
      VueUiAnnotator: ["config", "dataset"],
      VueUiCandlestick: ["config", "dataset"],
      VueUiChestnut: ["config", "dataset"],
      VueUiDashboard: ["config", "dataset"],
      VueUiDigits: ["config", "dataset"],
      VueUiDonut: ["config", "dataset"],
      VueUiDonutEvolution: ["config", "dataset"],
      VueUiGalaxy: ["config", "dataset"],
      VueUiGauge: ["config", "dataset"],
      VueUiHeatmap: ["config", "dataset"],
      VueUiKpi: ["config", "dataset"],
      VueUiMiniLoader: ["config"],
      VueUiMolecule: ["config", "dataset"],
      VueUiMoodRadar: ["config", "dataset"],
      VueUiNestedDonuts: ["config", "dataset"],
      VueUiOnion: ["config", "dataset"],
      VueUiQuadrant: ["config", "dataset"],
      VueUiRadar: ["config", "dataset"],
      VueUiRating: ["config", "dataset"],
      VueUiRelationCircle: ["config", "dataset"],
      VueUiRings: ["config", "dataset"],
      VueUiScatter: ["config", "dataset"],
      VueUiScreenshot: ["config"],
      VueUiSkeleton: ["config"],
      VueUiSmiley: ["config", "dataset"],
      VueUiSparkbar: ["config", "dataset"],
      VueUiSparkgauge: ["config", "dataset"],
      VueUiSparkHistogram: ["config", "dataset"],
      VueUiSparkline: ["config", "dataset"],
      VueUiSparkStackbar: ["config", "dataset"],
      VueUiTable: ["config", "dataset"],
      VueUiTableSparkline: ["config", "dataset"],
      VueUiThermometer: ["config", "dataset"],
      VueUiTiremarks: ["config", "dataset"],
      VueUiTreemap: ["config", "dataset"],
      VueUiVerticalBar: ["config", "dataset"],
      VueUiWaffle: ["config", "dataset"],
      VueUiWheel: ["config", "dataset"],
      VueUiXy: ["config", "dataset"],
      VueUiTableHeatmap: ["config", "dataset"],
      VueUiAccordion: ["config"],
      VueUiQuickChart: ["config", "dataset"],
      VueUiCursor: ["config"],
      VueUiSparkTrend: ["config", "dataset"],
      VueUiStripPlot: ["config", "dataset"],
      VueUiDumbbell: ["config", "dataset"],
      VueUiWordCloud: ["config", "dataset"],
      VueUiXyCanvas: ["config", "dataset"],
      VueUiFlow: ["config", "dataset"],
      VueUiParallelCoordinatePlot: ["config", "dataset"],
      VueUiTimer: ["config"],
      VueUiCarouselTable: ["config", "dataset"],
      VueUiGizmo: ["config", "dataset"],
      VueUiStackbar: ["config", "dataset"],
      VueUiBullet: ["config", "dataset"],
      VueUiFunnel: ["config", "dataset"],
      VueUiHistoryPlot: ["config", "dataset"],
      VueUiCirclePack: ["config", "dataset"]
    }, q = Q, d = s(() => !g[n.component]), Y = s(() => g[n.component] || null), i = o(null), J = s(() => {
      const t = K[n.component] || [], a = {};
      return t.includes("config") && (a.config = z.value), t.includes("dataset") && (a.dataset = j.value), a;
    }), V = o(() => null), U = o(() => null), f = o(() => null), v = o(() => null), k = o(() => null), S = o(() => null), h = o(() => null), y = o(() => null), b = o(() => null), C = o(() => null), A = o(() => null), T = o(() => null), P = o(() => null), D = o(() => null), x = o(() => null), I = o(() => null), F = o(() => null), H = o(() => null), L = o(() => null), B = o(() => null), E = o(() => null), _ = o(() => null), O = o(() => null), N = o(() => null);
    tt(() => {
      if (d.value)
        throw new Error(`

Vue Data UI exception:
The provided component "${n.component}" does not exist. Check the spelling.

Available components:

${Object.keys(g).map((t) => `. ${t}
`).join("")}`);
    }), G(i, async (t) => {
      t && (t.generatePdf && (V.value = t.generatePdf), t.generateImage && (f.value = t.generateImage), t.generateCsv && (U.value = t.generateCsv), t.getItemsPositions && (v.value = t.getItemsPositions), t.toggleReadonly && (k.value = t.toggleReadonly), t.shoot && (S.value = t.shoot), t.close && (h.value = t.close), t.restoreOrder && (y.value = t.restoreOrder), t.recalculateHeight && (b.value = t.recalculateHeight), t.toggleLock && (C.value = t.toggleLock), t.toggleTable && (A.value = t.toggleTable), t.toggleLabels && (T.value = t.toggleLabels), t.toggleSort && (P.value = t.toggleSort), t.toggleStack && (D.value = t.toggleStack), t.toggleTooltip && (x.value = t.toggleTooltip), t.start && (I.value = t.start), t.pause && (F.value = t.pause), t.reset && (H.value = t.reset), t.restart && (L.value = t.restart), t.lap && (B.value = t.lap), t.toggleAnimation && (E.value = t.toggleAnimation), t.pauseAnimation && (_.value = t.pauseAnimation), t.resumeAnimation && (O.value = t.resumeAnimation), t.toggleAnnotator && (N.value = t.toggleAnnotator));
    });
    const Z = () => {
      const t = [
        "selectLegend",
        "selectDatapoint",
        "toggleOpenState",
        "saveAnnotations",
        "selectRoot",
        "selectBranch",
        "selectNut",
        "change",
        "selectPlot",
        "selectSide",
        "rate",
        "postImage",
        "hoverIndex",
        "selectX",
        "toggleLock",
        "toggleTooltip",
        "start",
        "pause",
        "reset",
        "restart",
        "lap",
        "toggleAnimation",
        "pauseAnimation",
        "resumeAnimation",
        "toggleAnnotator"
      ], a = {};
      return t.forEach((p) => {
        a[p] = (...u) => q(p, ...u);
      }), a;
    }, r = et([]);
    G([r, i], () => {
      if (i.value)
        for (; r.length; ) {
          const [t, ...a] = r.shift();
          typeof i.value[t] == "function" && i.value[t](...a);
        }
    }), X({
      getData: (...t) => i.value && typeof i.value.getData == "function" ? i.value.getData() : r.push(["getData", ...t]),
      generatePdf: V,
      generateCsv: U,
      generateImage: f,
      getItemsPositions: v,
      toggleReadonly: k,
      shoot: S,
      close: h,
      restoreOrder: y,
      recalculateHeight: b,
      toggleLock: C,
      toggleTable: A,
      toggleLabels: T,
      toggleSort: P,
      toggleStack: D,
      toggleTooltip: x,
      start: I,
      pause: F,
      reset: H,
      restart: L,
      lap: B,
      pauseAnimation: _,
      resumeAnimation: O,
      toggleAnimation: E,
      toggleAnnotator: N
    });
    const l = s(() => {
      let t = `The provided component ${n.component} does not exist.`;
      return ["VueUiIcon", "VueUiPattern", "Arrow"].includes(n.component) ? (t = `${n.component} is not supported by the VueDataUi universal component. You must import it individually.`, console.warn(t), {
        status: "notSupported",
        message: t
      }) : (console.warn(t), {
        status: "unknown",
        message: t
      });
    });
    return (t, a) => d.value ? (c(), ot("div", {
      key: 0,
      style: it({
        width: "100%",
        display: "flex",
        gap: "6px",
        alignItems: "center",
        color: l.value.status === "notSupported" ? "#FF9000" : "#FF0000"
      })
    }, [
      at("div", Ut, [
        l.value.status === "unknown" ? (c(), m($, {
          key: 0,
          name: "moodFlat",
          stroke: "#FF0000"
        })) : M("", !0),
        l.value.status === "notSupported" ? (c(), m($, {
          key: 1,
          name: "circleExclamation",
          stroke: "#FF9000"
        })) : M("", !0)
      ]),
      nt(" " + rt(l.value.message), 1)
    ], 4)) : (c(), m(lt(Y.value), ut({
      key: 1,
      ref_key: "currentComponentRef",
      ref: i
    }, J.value, st(Z())), ct({ _: 2 }, [
      gt(t.$slots, (p, u) => ({
        name: u,
        fn: pt((R) => [
          mt(t.$slots, u, dt(Vt(R)))
        ])
      }))
    ]), 1040));
  }
};
export {
  St as default
};
